<?php 
/*
Plugin Name: GRA4 Social Network
Plugin URI: http://gra4.com/groups/profile/98/gra4-webmasters-wordpress
Description: Social network for WordPress.
Version: 0.0.5.7
Author: GRA4
Author URI: http://gra4.com
*/

/*
HOW TO INSTALL: 
	http://en.wiki.gra4.com/Category:GRA4_for_WordPress
	
WIKI: 
	http://wiki.gra4.com/
	
WORDPRESS PARTNERS GROUP:
	http://gra4.com/groups/profile/98/gra4-webmasters-wordpress
*/


if ( !isset($wp_did_header) ) //we called directly, not over WP?
{
//ATT: nope! also called from admin interface! Investigate later!
//	exit("GRA4 Social Network for WordPress not suppose to be called this way. <a href='http://wiki.gra4.com'>Read more...</a>");
}



//debug only
//gra4_remove_all_options(); die('no options now');

function gra4_remove_all_options() //for debug only
{
	delete_option('gra4_plugin_do_activation_redirect');
	delete_option('gra4_version');
	delete_option('gra4_dom_tree');
	delete_option('gra4_dom_node_id');
	delete_option('gra4_margin_none');
	delete_option('gra4_set_width');
	delete_option('gra4_delta_width');
	delete_option('gra4_set_custom_template');
	delete_option('gra4_reset_page');		
	delete_option('gra4_theme_name');		

}

function gra4_show_all_options() //for debug only
{
	echo("<br/>");
	echo("gra4_plugin_do_activation_redirect:".get_option('gra4_plugin_do_activation_redirect')."<br/>\n");
	echo("gra4_version:".get_option('gra4_version')."<br/>\n");
	echo("gra4_dom_tree:".get_option('gra4_dom_tree')."<br/>\n");
	echo("gra4_dom_node_id:".get_option('gra4_dom_node_id')."<br/>\n");
	echo("gra4_margin_none:".get_option('gra4_margin_none')."<br/>\n");
	echo("gra4_set_width:".get_option('gra4_set_width')."<br/>\n");
	echo("gra4_delta_width:".get_option('gra4_delta_width')."<br/>\n");
	echo("gra4_set_custom_template:".get_option('gra4_set_custom_template')."<br/>\n");
	echo("gra4_reset_page:".get_option('gra4_reset_page')."<br/>\n");
	echo("gra4_reset_page:".get_option('gra4_theme_name')."<br/>\n");	
}
//gra4_show_all_options(); //debug only



function gra4_echo_admin_msg($msg, $extra_br = false )
{
	echo('<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">');
	echo($msg);
	echo('</div>');
	if($extra_br === true)
	{
		echo('<br/>');
	}
}


function gra4_echo_no_mbstring_error()
{
	gra4_echo_admin_msg('<center>The <b>mbstring</b> extension library is not available.
					<br/>Please adjust your PHP configuration.
					<br><a target=_blank href="http://en.wiki.gra4.com/Category:Webmaster_guide#Requirements">more...</a>
					</center>');           
}

/*fix for versions 5.1, 5.2, we've supplied wrong custom.css file there*/
function gra4_customcss_is_ok($filename) 
{
	$handle = fopen($filename, "r");
	$contents = fread($handle, filesize($filename));
	fclose($handle);
	if(strpos($contents,'#branding') === FALSE)
	{
		return TRUE;
	}
	return FALSE;
}

error_reporting(E_ERROR); /*gonna show errors - in case some package is absent */
//ini_set("display_errors", 0); /*gonna keep settings of the client system*/


define('IN_GRA4', true); //so we go thru gra4 funcs
include_once('gra4_functions_local.php');
define ('GRA4_VERSION', GRA4GetLocalClientVersion());

/*
//v.55 ?
$aGRA4ContentPatterns = array('[GRA4_CONTENT]','<a href="http://gra4.com">GRA4 Social Network component</a> is not active');
$iBestGRA4ContentPattern = 0; 
*/

class gra4
{
//	function gra4()
	function __construct()	
    {
		ob_start(); //GRA4 may send headers out - so we prevent warning
		
		register_activation_hook( __FILE__, array( &$this, 'set_theme_options' ) );
		
		//Activation Hook
		register_activation_hook( __FILE__, array( &$this, 'activation_redirect' ) );
		
		add_action('init', array (&$this,'init_func'));
		
		add_filter('upgrader_pre_install', array (&$this,  'gra4_backup'));
		add_filter('upgrader_post_install', array (&$this, 'gra4_recover'));

        if (function_exists ('add_shortcode') )
        {
			add_shortcode('GRA4_CONTENT', array (&$this, 'content_func')); 
			
			add_filter( 'rewrite_rules_array', array (&$this, 'set_seo_friendly_rules'));			

			// admin page
			add_action('admin_menu',  array (&$this, 'admin_menu') );
			
			add_filter( 'plugin_action_links', array( $this, 'gra4_plugin_action_links'), 10, 2 );
			
			//top bar
			add_action( 'admin_bar_menu', array( $this, 'gra4_admin_bar_menu' ), 1000 );
			
			
			if (strstr($_SERVER['REQUEST_URI'], '/gra4'))
			{
				//we do it all the time, in case user changed the theme. no big deal, we just 
				//verify if file exists and do something only if we have to.
				//TODO - do it only if theme changed ?
				$this->update_gra4_template( get_option('gra4_set_custom_template'));
				
				//GRA4 supplies the dynamic content even for non-logged visitors.
				//Therefore we try to switch off caching for the GRA4 pages
				//WP Super Cache plugin documentation ( http://ocaoimh.ie/wp-super-cache-developers/ ) recommends this way:
				define('DONOTCACHEPAGE', true);
				define('DONOTMINIFY', true);
				//If it does not work, please upgrade the WP Super Cache plugin to the latest version and flush the caches.
				//we also going to try to stop other plugins from ading <p> abd <br/> to gra4 content.
				//hopefully they play by the rules.
				remove_filter( 'the_content', 'wpautop' );
				remove_filter( 'the_excerpt', 'wpautop' );

//				add_action('widgets_init', array (&$this,'remove_sidebars'), 20);
				
				add_action('wp_print_scripts', array (&$this, 'enqueue_scripts') );		
				add_filter('the_content', array (&$this, 'filter'));
				remove_action('template_redirect', 'redirect_canonical');
				add_filter( 'jetpack_enable_opengraph', '__return_false', 99 );
				add_filter('jetpack_enable_open_graph', '__return_false', 99);
			}
    	}

	}

	function gra4_admin_bar_menu() 
	{
		global $wp_admin_bar;
		$home_url = get_home_url(); 
		$img_path = plugins_url( 'gra4-social-network/img/gra4_icon.png' , dirname(__FILE__) );
//		$main_title = "<span style=\"background-image: url('$img_path');background-position:0;background-repeat: no-repeat;width:20px;height:20px;border:1px solid red; \">&nbsp;</span>GRA4";
		$main_title = "<span style=\"font-size: 12px; font-weight:bold; border:0px solid red; background-color:#ccc; color:#464646; border-radius:8px; height:20px;\">&nbsp;&nbsp;GRA4&nbsp;&nbsp;</span>";
		$wp_admin_bar->add_node( array( 'id' => 'GRA4_MENU0', 'title' => $main_title, 'href' => $home_url.'/gra4/' , meta => array('title'=>'Social Network') ) );
		$wp_admin_bar->add_node( array( 'id' => 'GRA4_MENU1', 'parent' => 'GRA4_MENU0', 'title' => 'My GRA4', 'href' => $home_url.'/gra4/', meta => array('title'=>'My Activity Stream') ) );	
		$wp_admin_bar->add_node( array( 'id' => 'GRA4_MENU2', 'parent' => 'GRA4_MENU0', 'title' => 'All Activity', 'href' => $home_url.'/gra4/activity/' , meta => array('title'=>'All Social Network Activity')) );	
		$wp_admin_bar->add_node( array( 'id' => 'GRA4_MENU3', 'parent' => 'GRA4_MENU0', 'title' => 'Messages', 'href' => $home_url.'/gra4/messages/' , meta => array('title'=>'My Inbox') ) );	

		
		
	}

	function activation_redirect() 
	{
		add_option('gra4_plugin_do_activation_redirect', true);
	}
	
	function admin_menu()
	{		
/*	
			add_submenu_page('options-general.php',	'GRA4', 'GRA4', 8, basename(__FILE__), 
							array (&$this,'admin_tools_page'),
							plugin_dir_url( __FILE__ ).'gra4_sm.png');
*/	
			add_menu_page( 'GRA4  Settings', 'GRA4  Settings', 8, basename(__FILE__), 
							array (&$this,'admin_option_page'),
							plugin_dir_url( __FILE__ ).'gra4_sm.png');
	}
	
	function admin_tools_page()
	{
		wp_redirect(admin_url('admin.php?page=gra4.php'));exit;
	}
	
	function gra4_plugin_action_links( $links, $file ) {
		if ( $file == plugin_basename( dirname(__FILE__).'/gra4.php' ) ) 
		{
//			$links[] = '<a href="' . admin_url("options-general.php?page=gra4.php") . '">GRA4 Settings</a>';
//			$links[] = '<a href="' . admin_url("admin.php?page=gra4.php") . '">GRA4 Settings</a>';	
			$links = array_merge(array('<a href="' . admin_url("admin.php?page=gra4.php") . '">GRA4 Settings</a>'),$links);
		}

		return $links;		
	}


	// Set default THEME option when the plug-in is activated
	function set_theme_options()
	{
		update_option('gra4_version', GRA4_VERSION);
		
		add_option('gra4_dom_tree', 'none');
		add_option('gra4_dom_node_id', '');
			
		add_option('gra4_margin_none', '1');
			
		add_option('gra4_set_width', 'none');
		add_option('gra4_delta_width', '0');
			
		add_option('gra4_set_custom_template', '1');
		
		if( get_option('gra4_set_custom_template') == '1')
		{
			$this->update_gra4_template( '1');
		}
		
		add_option('gra4_reset_page', '0');
	}


	function admin_info_page()
	{
		$plugin_dir_path = plugin_dir_path(__FILE__);
		?>
        <div class="wrap">      
        	<h2 style="color:#21759B;">GRA4 Social Network Plugin</h2>
        	<p><?php @readfile( $plugin_dir_path.'admin-text.txt') ?></p>        
        </div>
        <?php
    }

	function saved()	
	{
		?>
        <script type="text/javascript">
			jQuery('#result').html('Changes were successfully saved').show(1000);
		</script>
        <?php
	}
	
	
	
	function admin_option_page()
	{
     	define('IN_GRA4', true);
    	require_once('gra4_functions.php');
		?>
        <div class="wrap">      
<div id="top_wiki_link" style="float:right;">
<a title="Webmaster guide (Wiki)" target=_new href="http://en.wiki.gra4.com/Category:Webmaster_guide">
<h3 style="display:inline;">GRA4 Wiki Webmaster guide<img style="width:30px;height:30px;vertical-align:middle;"; src="http://en.wiki.gra4.com/skins/common/images/gra4_logo.jpg" /></h3>
</a>
</div>			
        	<h2 style="color:#21759B;">GRA4 Settings</h2>
			<hr />
            <div id="result"
            	style="background:#FF9; border-radius:10px; font-size:14px; padding:5px; display:none;">
        	</div>
		<?php
	  if(!gra4_is_private_ip($_SERVER['REMOTE_ADDR']))
		{
			gra4_echo_admin_msg("
			GRA4 is not intended to operate on a local machine.<br/>
			");
		  return;
	  }

	  $GRA4_secret = GRA4GetConfigValue('GRA4_secret');
		
		
// START here we double-check if user screwed something up
	$flag_is_page = $this->gra4_page_exists();
	$flag_is_permalink = $this->permalink_type_is_ok();
	if( !$flag_is_page OR !$flag_is_permalink )
	{
		$GRA4_secret = ''; //we simulate re-init
	}
//echo("|$flag_is_page|$flag_is_permalink|");	
// END here we double-check if user screwed something up

		
		
		
	  if( $GRA4_secret != '' OR strstr( $GRA4_secret, 'TMP') )
	  {
		?>
            <form  id="save_settings" method="post" >
		<?php
		$replace_flag = 0;
		$dom_options = '';
		$dom_node_id = '';
		$margin_option = '';
		$set_width = '';
		$delta_width = '0';
		
		if(count($_POST) > 0)
		{		
			if( $_POST['place']){
				$dom_options = $_POST['place'];
				update_option('gra4_dom_tree', $dom_options);
				$replace_flag = 1;
			}
			else
			{
				$dom_options = get_option('gra4_dom_tree');
			}
			
			// margin option
			if( $_POST['margin_none'])
			{
				update_option('gra4_margin_none', '0');
				$margin_option = 0;
				$replace_flag = 1;
			}
			else
			{
				$margin_option = 1;
				update_option('gra4_margin_none', '1');
			}
			// set width option
			if( $_POST['set_width'])
			{
				$set_width = $_POST['set_width'];
				update_option('gra4_set_width', $set_width);
				$replace_flag = 1;
			}
			else
			{
				$set_width = get_option('gra4_set_width');
			}
			
			// GRA4 custom template
			if( $_POST['set_custom_template'] == 'on' && get_option('gra4_set_custom_template') != '1'){
				$custom_template = '1';
				if( !$this->update_gra4_template( $custom_template)){
					$custom_template = get_option('gra4_set_custom_template');
				}
					
				if($custom_template == '1'){	
					update_option('gra4_set_custom_template', $custom_template);				
					$this->reset_DOM_settings();				
					update_option('gra4_reset_page', '1');
				}
				
				$dom_options = get_option('gra4_dom_tree');
				$dom_node_id = get_option('gra4_dom_node_id');
				$margin_option = get_option('gra4_margin_none');
				$set_width = get_option('gra4_set_width');
				$delta_width = get_option('gra4_delta_width');
			}
			elseif( $_POST['set_custom_template'] == 'on' && get_option('gra4_set_custom_template') == '1'){
				$custom_template = '1';
			}
			// GRA4 special position
			elseif( get_option('gra4_set_custom_template') == '1'){
				$custom_template = '0';
				if( !$this->update_gra4_template( $custom_template)){
				//	$custom_template = get_option('gra4_set_custom_template');
				}
					
				if($custom_template == '0'){					
					update_option('gra4_set_custom_template', $custom_template);
					update_option('gra4_reset_page', '1');					
				}
				
				$dom_options = get_option('gra4_dom_tree');
				$dom_node_id = get_option('gra4_dom_node_id');
				$margin_option = get_option('gra4_margin_none');
				$set_width = get_option('gra4_set_width');
				$delta_width = get_option('gra4_delta_width');
			}
			else{ 
				$custom_template = '0';
			 $dom_options = get_option('gra4_dom_tree');
			 $dom_node_id = get_option('gra4_dom_node_id');
			 $margin_option = get_option('gra4_margin_none');
			 $set_width = get_option('gra4_set_width');
			 $delta_width = get_option('gra4_delta_width');
			}
			$this->saved(); // info string
		}
		else
		{
			 $dom_options = get_option('gra4_dom_tree');
			 $dom_node_id = get_option('gra4_dom_node_id');
			 $margin_option = get_option('gra4_margin_none');
			 $set_width = get_option('gra4_set_width');
			 $delta_width = get_option('gra4_delta_width');
			 
			 $custom_template = get_option('gra4_set_custom_template');
		}
		
		
// GRA4 special position (get DOM tree)
	if($custom_template == '0'){
		
		include('vendors/simpledom/simple_html_dom.php');		
		$html = $this->remote_file_get_html( get_home_url().'/gra4/'); //like 'http://mydomen.ru/WP/gra4'
//		$html = $this->file_get_contents_curl( get_home_url().'/gra4/');
		if( $html){
			$ret = $html->getElementById('#gra4_wordpress');
			if( $ret){
				$tree = array();
				$tree[] = $ret->parent();
				$i = 0;
				while( $tree[$i]->tag != 'body'){
					$tree[] = $tree[$i]->parent();
					$i++;
				}
				$tree = array_reverse($tree);   // DOM tree
			}
			else{ //can`t get element #gra4_wordpress

				gra4_echo_admin_msg("This page does not contain the GRA4 content.<br/>",true);
				$tree = '';
			}
		}
		else $tree = '';   // Can`t get DOM
		
	}// END $custom_template == '0'
		
		?>
	
<p>
<input id="set_custom_template" name="set_custom_template" type="checkbox" onClick="g4_visualization_submit(this);"
        <?php
		if( $custom_template == 1)
		{
			echo ' checked="checked">';
		}
		else
		{
			echo '>';
		}
		?>
&nbsp;&nbsp;&nbsp;
Use Simplified Visualization.
</input>
 <a onClick="g4_open_test_window('<?php echo get_home_url().'/gra4/?wp_set=simple' ?>'); return false;" href="" title="Opens the front-end of your website in new window." target="_blank">Preview</a>
<script type="text/javascript">
var igGlobalPopup;
function g4_open_test_window(sUrl)
{
	igGlobalPopup = window.open(sUrl,'gra4_test_window','width=1100,height=600,scrollbars=yes');
	igGlobalPopup.focus();
}

function g4_open_test_window2(sUrl)
{
	setTimeout(function(){ g4_open_test_window_assync(sUrl); }, 500);
}

function g4_visualization_submit(id_2_gray)
{
	document.getElementById('save_settings').submit();	
	id_2_gray.disabled = true;
	
}

function g4_change_visualization(bSimple)
{
		var idVisualization = document.getElementById("set_custom_template");
		idVisualization.checked=bSimple; 
		g4_visualization_submit(idVisualization);
		document.getElementById("save_settings").submit(); 
		return false;
}
</script>


<div id="simplified_visualization_block" style="border:solid red 0px;">
<h2>Simplified Visualization</h2>	
<br/>Simplified Visualization uses custom GRA4 theme template. This setting works for the most of the themes. 
<a onClick="g4_open_test_window('<?php echo get_home_url().'/gra4/?wp_set=simple' ?>'); return false;" href="" title="Opens the front-end of your website in new window." target="_blank">See how your social network looks</a>. 
<br>If the content of your GRA4 subsystem looks too shifted to the right or to the bottom, or is obscured by other elements,
try to switch off the sidebars for the GRA4 page. If it does not help (or your custom theme does not have such option), use the 
<a onClick="g4_change_visualization(false); return false;" href="" title="Switch to Extended Visualization">Extended Visualization</a>.
</p>
</div> <?php /* "simplified_visualization_block" end*/?>

<div id="extended_visualization_block" style="border:solid blue 0px;">
	<h2>Extended Visualization</h2>

<p>Extended Visualization uses complicated Javascript-powered DOM positioning. 
<br/>Recommended only if your social content looks shifted, or overlaps with a sidebar.<br/>
Some Themes do not provide options to hide sidebars for a particular page, or too narrow to accommodate the GRA4 content.<br/>
If in the default position your social content collides with other elements of the page, 
you may want to move the GRA4 block up in the page elements hierarchy, 
change width of the upper elements, or suppress the frame of the parent element of the social content block.<br/>
Unfortunately, there is to universal settings working for every custom theme, so you will have to experiment a bit.
Play with the controls, and don't forget to save options before you 
<a onClick="g4_open_test_window('<?php echo get_home_url().'/gra4/?wp_set=extended' ?>'); return false;" href="" title="Opens the front-end of your website in new window." target="_blank">view the results</a>,
so your changes will take effect. The <a href="#video_tutorial">video tutorial</a> may help,
<br>If you are not satisfied with the results, you can always return to the 
<a onClick="g4_change_visualization(true); return false;" href="" title="Switch to Simplified Visualization">Simplified Visualization</a>.
</p>

<?php
	if( $custom_template == '0'){
?>
<script>
function g4_set_extedned_default(theme_id)
{
	if(theme_id == 'wp10')
	{
		var id_p = document.getElementById('place_main');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_wrapper');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = true;
	}
	if(theme_id == 'wp11')
	{
		var id_p = document.getElementById('place_main');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_main');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = true;
	}
	if(theme_id == 'wp13')
	{
		var id_p = document.getElementById('place_main');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_primary');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = true;
	}
	if(theme_id == 'wp14')
	{
		var id_p = document.getElementById('place_content');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_gra4');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = true;
	}
	
	
	if(theme_id == 'wp_reset')
	{
		var id_p = document.getElementById('place_gra4');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_gra4');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = false;
	}
	
	return false;	
}
</script>
Example: set the default values for WordPress standard theme 
[<a onClick="return g4_set_extedned_default('wp10')" href='javascript:void(0);' title="Set the Settings like for the Twenty Ten theme where possible.Block position:'main',Make wider:'wrapper',Parent frame:suppressed"><b>Twenty Ten</b></a>],
[<a onClick="return g4_set_extedned_default('wp11')" href='javascript:void(0);' title="Set the Settings like for the Twenty Eleven theme where possible.Block position:'main',Make wider:'default',Parent frame:suppressed"><b>Twenty Eleven</b></a>], 
[<a onClick="return g4_set_extedned_default('wp11')" href='javascript:void(0);' title="Set the Settings like for the Twenty Twelve theme where possible.Block position:'main',Make wider:'default',Parent frame:suppressed"><b>Twenty Twelve</b></a>], 
[<a onClick="return g4_set_extedned_default('wp13')" href='javascript:void(0);' title="Set the Settings like for the Twenty Thirteen theme where possible.Block position:'main',Make wider:'default',Parent frame:suppressed"><b>Twenty Thirteen</b></a>], or
[<a onClick="return g4_set_extedned_default('wp14')" href='javascript:void(0);' title="Set the Settings like for the Twenty Fourteen theme where possible.Block position:'content',Make wider:'default',Parent frame:suppressed"><b>Twenty Fourteen</b></a>], or
[<a onClick="return g4_set_extedned_default('wp_reset')" href='javascript:void(0);' title="Reset the Settings for default values.Block position:'default',Make wider:'default',Parent frame:not suppressed"><b>reset</b></a>]

<table>
<tr><td style=" font-weight:bold; text-align:center">GRA4 block position</td>
<td style=" font-weight:bold; text-align:center">Make wide</td></tr>
<tr >
<td width="300px" style="border-top:1px solid #21759B; border-bottom:1px solid #21759B;">
		<?php
		$step = '&nbsp;';
		echo '<input name="place" id="place" type="radio" disabled value="body"';
		echo '> '.$step.'BODY</input><br/>';
		$step .= '&nbsp;';		
		for( $i=1; $i < count($tree); $i++){
			if( $tree[$i]->id){
				$treeId = ' id='.$tree[$i]->id;
				
				echo "\n".'<input name="place"  id="place_'.$tree[$i]->id.'" type="radio" value="'.$i.'"';
				if( $dom_options == $i){
				 	echo ' checked="checked"';
					$replace_string = $tree[$i]->id;
					update_option('gra4_dom_node_id', $replace_string);
				}
				echo '> ';
			 	echo $step.$tree[$i]->tag.$treeId.'</input><br/>';
				$step .= '&nbsp;&nbsp;';
			}
		}
		echo '<br/><input name="place" type="radio" id="place_gra4" value="none"';
		if( $dom_options == 'none') 
			echo ' checked="checked" ';
		echo '> '.$step.'GRA4 default position</input><br/>';
		
		?>
</td>
<td width="300px" style="border-top:1px solid #21759B; border-bottom:1px solid #21759B;">
		<?php
		$step = '&nbsp;';
		echo '<input id="set_width" name="set_width"  type="radio" disabled value="body"';
		echo '> '.$step.'BODY</input><br/>';
		$step .= '&nbsp;';		
		$last_i = 0;		
		for( $i=1; $i < count($tree); $i++){
			if( $tree[$i]->id){
				$treeId = ' id='.$tree[$i]->id;
				
				echo "\n".'<input name="set_width" id="set_width_'.$tree[$i]->id.'" type="radio" value="'.$i.'"';
				if( $set_width == $i){
				 	echo ' checked="checked"';
					$set_width = $i;
				}
				echo '> ';
			 	echo $step.$tree[$i]->tag.$treeId.'</input><br/>';
				$step .= '&nbsp;&nbsp;';
				$last_i = $i;				
			}
		}
		$last_i++;
		echo '<br/><input name="set_width" type="radio" id="set_width_gra4" value="'.$last_i.'"';
		if( $set_width == $last_i OR $set_width == 'none' ) echo ' checked="checked" ';
		echo '> '.$step.'GRA4 block</input><br/>';
		
		// get DELTA
		if($dom_options == 'none'){
			$delta_width = $last_i - $set_width;
		}
		else{
			$delta_width = $dom_options - $set_width;
		}
		update_option('gra4_delta_width', $delta_width);
		?>

</td>
</tr>
</table>        

        <br/>
		<span title='To maximize space available for the social content, you also may want to suppress the frame of the parent element of the GRA4 block. '>
		<input type="checkbox" id="margin_none" name="margin_none" 
        <?php
		if($margin_option == 1)
		{
			echo '>';
		}
		else
		{
			echo ' checked="checked">';
		}
		?>
        
        	&nbsp;      Suppress parent frame
        </input>
		</span>
        
        <?php
//fails in some configurations
//		$html->clear(); // clean data
		unset($html);
		
		if($replace_flag == 1){
			$this->set_place($replace_string, $margin_option, $delta_width);
			update_option('gra4_reset_page', '1');
		}
		?>
        
<?php
	}	// END if( $custom_template == '0')
	else{
?>		
<?php
	}
?>        
        <br/>
   			<input type="hidden" name="action" value="update" />
   			<input type="hidden" name="replace_string" value="<?php echo $replace_string?>" />
            <br/>
   			<input type="submit" onClick="g4_open_test_window('about:blank');" name="Submit" value="<?php _e('Save and view the results') ?>" />(Preview of the front-end of your social network will be shown in a pop-up window)
 
		</form>
</div> <?php /* "extended_visualization_block" end*/?> 
<?php
		if( $custom_template == '0'){ 
?>
<a name="video_tutorial"></a>
<h3>Extended Visualization Video Tutorial</h3>
<iframe width="480" height="360" src="http://www.youtube.com/embed/ORBR8ql_UPw?rel=0" frameborder="0" allowfullscreen></iframe>

<?php
	}	
?>
<script>
function gra4_change_visualization()
{
	var idVisualization = document.getElementById("set_custom_template");
	var idSimplifiedBlock = document.getElementById("simplified_visualization_block");
	var idExtendedBlock = document.getElementById("extended_visualization_block");
	if(idVisualization && idSimplifiedBlock && idExtendedBlock)
	{
		if(idVisualization.checked == true)	//show simplified
		{
			idExtendedBlock.style.display = 'none';
			idSimplifiedBlock.style.display = 'inline';		
		}
		else //show extended
		{
			idExtendedBlock.style.display = 'inline';
			idSimplifiedBlock.style.display = 'none';		
		}
	}
	else //we don't have something!
	{
		alert("Error !\n" + idVisualization + "\n" + idSimplifiedBlock + "\n" + idExtendedBlock);	
	}
}
gra4_change_visualization();
</script>


<hr />
<h2>Useful links</h2>
<p>If you done with the configuration, you may want to <a title="<?php echo get_home_url().'/gra4'; ?>" href="<?php echo get_home_url().'/gra4'; ?>">visit your social network</a> and</p>
<p>

- Edit your Profile (<a title="Read more at GRA4 Wiki" href="http://en.wiki.gra4.com/Profile">wiki</a>)<br/>
- Change your Avatar (<a title="Read more at GRA4 Wiki" href="http://en.wiki.gra4.com/Avatar">wiki</a>)<br/>
- Visit your Groups, configure the default group of your website, it will help you to manage and promote your social community.<br/>
- Take a look at the 
<a title="<?php echo get_home_url().'/gra4'; ?>/groups/profile/98/gra4-webmasters-wordpress/" href="<?php echo get_home_url().'/gra4'; ?>/groups/profile/98/gra4-webmasters-wordpress/" >
GRA4 for WordPress</a>
and 
<a title="<?php echo get_home_url().'/gra4'; ?>/groups/profile/94/gra4-webmasters/" href="<?php echo get_home_url().'/gra4'; ?>/groups/profile/94/gra4-webmasters/" >
GRA4 Webmasters</a> groups.</p>
<!--
<p>See <a href="<?php echo admin_url().'admin.php?page=admin_info_page' ?>">Info</a> page for additional information.</p>
-->
<?php
//going to view results 
	if(isset($_POST['Submit'])) 
	{
		echo('<script>g4_open_test_window("'.get_home_url().'/gra4/?wp_set=submit");</script>');	
	}
	else
	{
//print_r($_POST);		
	}
	

?>        
       <?php
	  }// END registered in GRA4
	  
	  
	  else
	  {
		if(!extension_loaded('mbstring')) 
		{
			gra4_echo_no_mbstring_error(); //admin
		}
		else
		{
			$flag_is_page = $this->gra4_page_exists();
			$flag_is_permalink = $this->permalink_type_is_ok();
			if( !$flag_is_page OR !$flag_is_permalink ){  // page OR permalink not exist
				if( $_POST['Install_page'] )
				{ 
					if( !$flag_is_page){ // We create page aromatically
			  			if( $this->create_gra4_page()){
							$flag_is_page = true;
							gra4_echo_admin_msg("The page <b>GRA4 Social Network</b> has been successfully created .<br/>");
						}
						else{
							gra4_echo_admin_msg("
			An error occurred during the automatic page creation. Please try to create the page manually.
            <br/>
			See <a href='http://wiki.gra4.com/'>GRA4 Wiki</a> for more information.
							");
						}
					}  // !$this->is_gra4_page()
					
					if( !$this->permalink_type_is_ok() ){
						$this->set_permalink_type_postname(); // We create permalink atomatically
						$flag_is_permalink = true;
						gra4_echo_admin_msg("The permalink settings have been successfully adjusted.<br/>");
					}

					if( $flag_is_permalink AND $flag_is_page){ // All right
					gra4_echo_admin_msg("
			Your System is ready for the GRA4 Social Network operation. <br/>
			To complete the installation process please visit your GRA4 subsystem (will be opened in new window). <br/>
			<br/>If GRA4 content in your theme looks shifted, please switch to Extended Visualization in the GRA4 Settings.
						");
						?>
		<br/><br/><button style="font-weight:bold;" onClick="window.open('<?php echo get_home_url().'/gra4'; ?>');window.location.href='<?php echo get_home_url().'/wp-admin/admin.php?page=gra4.php'; ?>';"><?php _e(' Complete the installation of GRA4 Social Network &gt;&gt; ') ?></button>
		

        				<?php
					}
					
				}
				else{		// GRA4 page or permalink not found
					if( !$flag_is_permalink AND !$flag_is_page){ // GRA4 page and permalink not found
						gra4_echo_admin_msg("
			To operate properly the GRA4 Social Network requires 			
			the GRA4 page to exist, and the Permalink Settings to be set to something other than the 'default'. <br/>
			When the installation continues, the appropriate changes will be made automatically.<br/>
			The changes are not going to affect current functionality of your system. <br/>
							",true);
					}
					elseif(!$flag_is_permalink){ // only GRA4 permalink not found
						gra4_echo_admin_msg("
            To operate properly the GRA4 Social Network requires the Permalink Settings to be set to something other than the 'default'.<br/>
			When the installation continues, the appropriate changes will be made automatically.<br/>
            The change is not going to affect current functionality of your system. <br/>
						",true);
					}
					elseif(!$flag_is_page){  // only GRA4 page not found
					gra4_echo_admin_msg("
			To operate properly the GRA4 Social Network requires the GRA4 page to exist.<br/>
			When the installation continues, the page will be created automatically.<br/>
			The change is not going to affect current functionality of your system. <br/>
					",true);
					}
					?>
    	        	<form method="post" name="page_install">
   						<input type="hidden" name="action" value="update" />
   						<input type="submit" style="font-weight:bold;" name="Install_page" value="<?php _e(' Adjust the Settings automatically and continue &gt;&gt; ') ?>" />
					</form>
					<br/>
					<?php
				}

        	} // END if( !$flag_is_page OR !$flag_is_permalink)
			else{	 // All right
				gra4_echo_admin_msg("
			Your system is ready for the GRA4 Social Network operation. <br/>
			To complete the installation process please visit your GRA4 subsystem (will be opened in new window). <br/>
			<br/>If GRA4 content in your theme looks shifted, please switch to Extended Visualization in the GRA4 Settings.
				",true);
		?>
			<br/><button style="font-weight:bold;" onClick="window.open('<?php echo get_home_url().'/gra4'; ?>');window.location.href='<?php echo get_home_url().'/wp-admin/admin.php?page=gra4.php'; ?>';"><?php _e(' Complete the installation of GRA4 Social Network &gt;&gt; ') ?></button> 
	
          		<?php 
			}
		  
		}
	  }// END dont registered in GRA4
	  
		// div class="wrap"?>
        </div>
        <?php

 	}

	function gra4_page_exists($bCheckConent = TRUE)
	{
		$pages = get_pages(); //only 'publish'?
		foreach ( $pages as $page ) 
		{
			if( ($page->post_name == 'gra4') && ($page->post_status == 'publish') )
			{
				if($bCheckConent === TRUE)
				{
					if(mb_strpos($page->post_content,'[GRA4_CONTENT]') !== FALSE)
					{
						return true;	// page exist
					}
				}
				else //don't have to check content
				{
					return true;	// page exist
				}
			}//if permalink and published
  		}//foreach
//die("123");		
		return false; 	// so far page not found
	}
	
	function restore_permalink_from_trash()
	{
		//going to blindly restore from trash
		global $wpdb;
		$wpdb->query("UPDATE $wpdb->posts SET post_status = 'publish'  WHERE post_status = 'trash' AND post_type = 'page' AND post_name = 'gra4' ");
		
	}		
	
	function delete_all_with_gra4_permalink()
	{
		//going to blindly restore from trash
		global $wpdb;
		$wpdb->query("DELETE FROM $wpdb->posts WHERE post_type = 'page' AND post_name = 'gra4' ");
	}		
	
	
	function insert_gra4_mark()
	{
		//going to blindly insert '[GRA4_CONTENT]' to the page with appropriate permalink
		global $wpdb;
		$wpdb->query("UPDATE ".$wpdb->posts." SET post_content = CONCAT('[GRA4_CONTENT] ',post_content) WHERE post_status = 'publish' AND post_type = 'page' AND post_name = 'gra4' ");
	}
	
	function create_gra4_page() 
	{
		$bRet = false;
		
		$this->delete_all_with_gra4_permalink(); //we here only if right page does not exist
		$bRet = $this->create_new_gra4_page(); //return whatever function returns
//looks like list of pages is not updated immediatelly, therefore we can't check by	gra4_page_exists()
/*		
		$this->restore_permalink_from_trash(); //restore from trash
//return true;	
		if($this->gra4_page_exists(TRUE)) //exists with correct permalink AND content
		{
			$bRet = true; //restired from trash - exists
		}
		else //still does not exist
		{
			if($this->gra4_page_exists(FALSE)) //exists with correct permalink but NO content
			{
				insert_gra4_mark();
			}
			if(!($this->gra4_page_exists(TRUE))) //exists with correct permalink AND content
			{
				$bRet = $this->create_new_gra4_page(); //return whatever function returns
			}
			else
			{
				$bRet = true; //exists now
			}
		}	
*/	
		return $bRet;
	}
	
	function create_new_gra4_page()
	{
			$new_gra4_post = array(
   				'post_title' => 'GRA4 Social Network',
				'post_name' => 'gra4',
   				'post_content' => '[GRA4_CONTENT]',
   				'post_status' => 'publish',
				'post_type' => 'page',
				'comment_status' => 'closed',
			);  
			if( ($gra4_post_id = wp_insert_post( $new_gra4_post )) != '0')
				return true;
			else
				return false;				
	}

	function permalink_type_is_ok(){
		global $wp_rewrite;
		$permalink_structure = get_option('permalink_structure');
		if( $permalink_structure)
			return true;
		else
			return false;
	}
	
	function set_permalink_type_postname()
	{
		global $wp_rewrite;
		$permalink_structure = '/%postname%/';
		$wp_rewrite->set_permalink_structure( $permalink_structure );
		flush_rewrite_rules();
	}


	// Set GRA4 position on the page
	function set_place( $replace_string, $margin = 1, $delta_width = -1)
	{
		$fileName = plugin_dir_path(__FILE__).'js/header.js';  //todo prefix!
		if ( file_exists($fileName)) {
			$strings = file($fileName);
			$strings[0] = "var place = '$replace_string';\r\n";
			
			if( $margin == 0){
				$strings[1] = "var margin = '0';\r\n";
			}
			else
			{
				$strings[1] = "var margin = '1';\r\n";
			}
			
//			if( $delta_width < 0){
//				$strings[2] = "var set_width = 0;\r\n";
//			}
//			else
			{
				$strings[2] = "var set_width = $delta_width;\r\n";
			}
			
			file_put_contents ($fileName, $strings);		
		}
		else{
    		echo "ERROR: Please make sure file 'header.js' do exist in the plugin 'js' directory.";
		}
	}


	function install_gra4_template()
	{
		$path_template = plugin_dir_path(__FILE__).'page-gra4.php';
		if( file_exists( $path_template)){
//			$current_theme = WP_CONTENT_DIR . get_raw_theme_root() . '/' . get_stylesheet();
			$current_theme = get_stylesheet_directory();
			$path_to_copy = $current_theme.'/page-gra4.php';
			if( copy($path_template, $path_to_copy)){
				return true;
			}
			else{
				//echo 'Can not install the GRA4 Custom Theme Template at ' . $path_template;
				return false;
			}
		}
	}
		
	function delete_gra4_template()
	{
//	$current_theme = WP_CONTENT_DIR . get_raw_theme_root() . '/' . get_stylesheet();
		$current_theme = get_stylesheet_directory();
		$path_to_delete = $current_theme.'/page-gra4.php';
		if(file_exists($path_to_delete))
		{
			if( unlink( $path_to_delete)){
				return true;
			}
			else{
				echo 'Can not uninstall the GRA4 Custom Theme Template at ' . $path_to_delete; //that's ok, we delete only is exists
				return false;
			}
		}		
	}
		
	function update_gra4_template($set_gra4_template)
	{
		if( $set_gra4_template == '1')// template ON
			return $this->install_gra4_template();
		else //not 1, 0 or not set
		{
			return $this->delete_gra4_template();
		}
	}

	function reset_DOM_settings()
	{
		update_option('gra4_dom_tree', 'none');
		update_option('gra4_dom_node_id', '');			
		update_option('gra4_margin_none', '1');			
		update_option('gra4_set_width', 'none');
		update_option('gra4_delta_width', '0');
		
		$from = plugin_dir_path(__FILE__).'js/header.js_';
		$to = plugin_dir_path(__FILE__).'js/header.js';
	    if ( is_file($from) && is_file($to)) {
	        return copy($from, $to);
	    }
		else	return false;
	}

	
	function get_pageid()
	{
		global $post;
//return print_r($post,true);	
		$strPageId = $post->ID;
/*	
		global $wpdb;
		$strPageId=  $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_content LIKE '%[GRA4_CONTENT]%' AND post_status = 'publish' AND post_type = 'page'");
*/		
		return $strPageId;
	}

	
	function content_func($atts) 
	{
     	define('IN_GRA4', true);
		require_once('gra4_functions.php');	
		
		if( !gra4_is_private_ip($_SERVER['REMOTE_ADDR'])) 
		{
			gra4_echo_admin_msg("GRA4 is not intended to operate on a local machine.<br/>");
			return;
		}
		
		if(!extension_loaded('mbstring')) //front-end
		{
			gra4_echo_no_mbstring_error();
			return;
		}
		
		

//To give a hint to the people who do not read README files =)
	    if(mb_strpos($_SERVER['REQUEST_URI'],'/gra4') === false)
	    {
		    return("FATAL ERROR: Can't process the URL ! Permalink of this page is not set to 'gra4'? Permalink Settings are set to 'Default'? ");
    	}


		$strShortSelf = str_replace(mb_strrchr($_SERVER['PHP_SELF'], '/'), '', $_SERVER['PHP_SELF']);

		$aCssNames = explode(',', $aGRA4GlobalConfig['include_css']);


		for ($i = 0; $i < count($aCssNames); $i++) 
		{
			
	    	if ( trim($_SERVER['REQUEST_URI'] , '/') == trim($strShortSelf . '/gra4' . $aCssNames[$i],'/') ) 
			{

	        	$strFileName = dirname(__FILE__) . $aCssNames[$i]; //see gra4_config.php
				

				if (file_exists($strFileName)) {
		        	$strFileContent = file_get_contents($strFileName);

					ob_clean();

			        header("Content-Type:	text/css;charset=UTF-8 \r\n");
				// Tell the user agent to cache this stylesheet for an hour
					$age = 3600;
					header( 'Expires: '.gmdate( 'D, d M Y H:i:s', time()+ $age ) . ' GMT' );
					header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s', @filemtime( $strFileName ) ) . ' GMT' );
					header( 'Cache-Control: public, max-age='.$age.', must-revalidate, post-check=0, pre-check=0' );
					header( 'Pragma: public' );
			        exit($strFileContent); //we done!
				}
				else
				{
				    echo "The file $filename does not exist";
				}

			}

		//WORDPRESS SPECIFIC: we have to add '/' to file names, that's how SEO-friendly URLs are created in WordPress

		//Tag must look like <link  rel="stylesheet" href="http://SomeServer.com/wordpress/gra4/css/custom.css/" type="text/css" />

		//If we have '...custom.css', not '...custom.css/', it will cause redirect, and stylesheet file will never get cached.

//			$aCssNames[$i] = $aCssNames[$i] . '/'; //so we fix it in array

		}

		$aGRA4GlobalConfig['include_css'] = implode(',',$aCssNames); //and put it back, already with '/'

		//ok, if we here - we've got real content
		$permalink = get_permalink( $this->get_pageid()); //like 'http://server.com/wordpress/gra4/'
		$link = trim(str_replace(array(site_url(), 'index.php/'), '', $permalink), '/'); //like 'gra4'.

	if($link != 'gra4') {
		$content = '';
	}
	else {
		$bFrameNeeded = true;
   	$content = GRA4FetchRemoteContent($bFrameNeeded);
		if($bFrameNeeded === false) {
			ob_clean();
			exit($content);
		}
	}

//We do it to use default template, otherwise everything will be shifter right, and blink.
// so we display it hidden, and show only when custom.css is loaded.
//REDO! when we switch to custom template.
//Note: '.entry-header,.entry-title' here is butt-ugly, 
//  but otherwise it will blick "GRA4" into user eyes... looks like 24th frame =)
//	<div style="display:block; overflow:auto;">

		$alarm = '';
		if( get_option('gra4_reset_page') == '1')
		{
			update_option('gra4_reset_page', '0');
			$alarm = '
<div  style="position:fixed; text-align1:center;	padding:10px; font-size:12px; color:#FFF; background:#F00; border-radius:10px; margin-top:100px; z-index:99999; top:10px; left:45%; font-weight1:bold;">
Visualization settings have been changed. <br/>
Please wait while fresh copy of this page loads from the server.<br/>
If page is not loaded, <a title="click to reload the page" href="javascript:window.location.reload(true);">click here to forcefully reload the page</a> .
</div>
<script>window.location.reload(true);</script>
			';
		}

	$start = '
	<style type="text/css">#gra4_wordpress, .entry-header, .entry-title {display:none;}</style>
		<div id="gra4_wordpress"  >';

//not going to hide content for custom template 		
	if( get_option('gra4_set_custom_template') == '1')
	{
		$start = '<div id="gra4_wordpress">'; 
	}
		
	$end = '</div>';

	if($link != 'gra4') {
	
	if($link == '')
	{
		$link = 'empty';
	}
	
			$p_alarm = '
<div  style="text-align:center;	padding:10px; font-size:12px; background:#FC3; border-radius:10px;  z-index:99999;">
The permalink of page is <strong>'.$link.'</strong> . Please set it to <strong>gra4</strong>. <br/>Read more at <a href=http://wiki.gra4.com>wiki.gra4.com</a>.
</div>
			';
		$content = $start.$p_alarm.$end;
	}
	else {
		$content = $start.$content.$alarm.$end;
	}

		return $content;
	}//END content_func
		
	
	

	function set_seo_friendly_rules($args)
	{

		$new = array();

		$permalink = get_permalink( $this->get_pageid()); //like 'http://server.com/wordpress/gra4/'

		$link = trim(str_replace(array(site_url(), 'index.php/'), '', $permalink), '/'); //like 'gra4'. 

		if($link !== '1gra4')
		{

//TODO - add error message ?

		}

		$new['(gra4)(/[-/0-9a-zA-Z]+)?/(.*)$'] = 'index.php?pagename=$matches[1]&page=$matches[2]'; //using constant

		return $new + $args;
	}


	function filter($content = '') {
		remove_all_filters('the_content');
		add_filter('the_content', array (&$this, 'filter'));
		
		if ( '' == $content || !strstr($content, '[GRA4_CONTENT]') ) { ob_flush();return $content; }
		return do_shortcode( '[GRA4_CONTENT]' );
	}


	function register_scripts() {
		wp_register_script(
		    'gra4_functions', //id
			plugin_dir_url(__FILE__).'js/functions.js',
		    array('jquery'), //dependency 
		    null, //version
		    false //in the header
//		    true //in the body body
		);	 
		wp_register_script(
		    'gra4_script', //id
			plugin_dir_url(__FILE__).'js/header.js',
		    array('jquery'), //dependency
		    null, //version
		    false //in the header
//		    true //in the body
		);	 
	}

	function enqueue_scripts(){
	  if (!is_admin()):
	    wp_enqueue_script('gra4_functions');
	    wp_enqueue_script('gra4_script');
	  endif; //!is_admin
	}


	function init_func($atts) 
	{
		// UPDATE 
		if( get_option('gra4_version') != GRA4_VERSION){
			
			add_option('gra4_dom_tree', 'none');
			add_option('gra4_dom_node_id', '');
			add_option('gra4_margin_none', '1');
			add_option('gra4_set_width', 'none');
			add_option('gra4_delta_width', '0');
			add_option('gra4_reset_page', '0');
			
			if( !get_option('gra4_set_custom_template')){
				add_option('gra4_set_custom_template', '0');
				update_option('gra4_version', GRA4_VERSION);
				$gra4_dom_node_id = get_option('gra4_dom_node_id');
				$margin_option = get_option('gra4_margin_none');
				$delta_width = get_option('gra4_delta_width');
			
				$this->set_place( $gra4_dom_node_id, $margin_option, $delta_width);			
			}
		} // end UPDATE
		
		
	// flush_rules() if our rules are not yet included
		$this->register_scripts();

		$rules = get_option('rewrite_rules' );

	//comment line bellow if you want to force flush
		if( ! isset( $rules['(gra4)(/[-/0-9a-zA-Z]+)?/(.*)$'] ) ) //don't have to do it every time
		{
			global $wp_rewrite;
		   	$wp_rewrite->flush_rules();
		}
	//do jump 
		if (get_option('gra4_plugin_do_activation_redirect', false)) 
		{
			delete_option('gra4_plugin_do_activation_redirect');
			if(!isset($_GET['activate-multi']))
			{
				wp_redirect(admin_url('admin.php?page=gra4.php')); 
//				wp_redirect( admin_url('tools.php?page=gra4.php') ); 
//				wp_redirect( admin_url('options-general.php?page=gra4.php') ); 				
			}
		}			
	}//init_func()

	// copy file pre/post update plugin
	function gra4_copy($file, $source, $dest)
	{
	    // Make destination directory
	    if (!is_dir($dest)) {
	        mkdir($dest);
	    }		
	    // Simple copy for a file
	    if (is_file($source.$file)) {
	        return copy($source.$file, $dest.$file);
	    }	 
	    return true;
	}
	
	
	function gra4_backup($atts)
	{
		$upload_dir = wp_upload_dir(); 
       	$to = $upload_dir['path'].'/gra4_backup/';
		
        $from = dirname(__FILE__).'/css/';
		$file = 'custom.css';
		
	  	if( file_exists($from.$file) )
		{
			if(gra4_customcss_is_ok($from.$file))
			{
				$this->gra4_copy($file, $from, $to);
			}
			else // wrong custom.css placed there in versions 5.1, 5.2
			{
				unlink($from.$file); //force it
			}
		}
				
	    $from = dirname(__FILE__)."/";
		$file = 'gra4.cfg';
	    $this->gra4_copy($file, $from, $to);
		
	    $from = dirname(__FILE__)."/js/";
		$file = 'header.js';
	    $this->gra4_copy($file, $from, $to);
	}
	
	function gra4_recover($atts)
	{
		$upload_dir = wp_upload_dir(); 
        $from = $upload_dir['path'].'/gra4_backup/';
		
        $to = dirname(__FILE__)."/css/";
		$file = 'custom.css';
	  	if( file_exists($from.$file)){
        	$this->gra4_copy($file, $from, $to);
			unlink($from.$file);
	  	}
			
        $to = dirname(__FILE__)."/";
		$file = 'gra4.cfg';
        $this->gra4_copy($file, $from, $to);
		unlink($from.$file);

        $to = dirname(__FILE__)."/js/";
		$file = 'header.js';
        $this->gra4_copy($file, $from, $to);
		unlink($from.$file);
			
        if (is_dir($from)) {
        	rmdir($from);
		}
	}


// additional DOM function
	function remote_file_get_html($url, $use_include_path = false, $context=null, $offset = -1, $maxLen=-1, $lowercase = true, $forceTagsClosed=true, $target_charset = DEFAULT_TARGET_CHARSET, $stripRN=true, $defaultBRText=DEFAULT_BR_TEXT, $defaultSpanText=DEFAULT_SPAN_TEXT)
	{
	    $dom = new simple_html_dom(null, $lowercase, $forceTagsClosed, $target_charset, $stripRN, $defaultBRText, $defaultSpanText);
	
//		if( ini_get( 'allow_url_fopen') != 'off')
//		    $contents = file_get_contents($url, $use_include_path, $context, $offset);
//		else
			$contents = $this->file_get_contents_curl($url);
	
	    if (empty($contents) || strlen($contents) > MAX_FILE_SIZE)
	    {
	        return false;
	    }
		
	    $dom->load($contents, $lowercase, $stripRN);
	    return $dom;
	}

	function file_get_contents_curl($url) {
		if( !($ch = curl_init($url))){
			echo "FATAL ERROR:  cUrl are not allowed in your system. GRA4 Does now know how to talk to the server...  =( ";
			return '';
		}
		
		$options = array(
        	CURLOPT_RETURNTRANSFER => true, // return data
	        CURLOPT_HEADER => false, //not return headers			
        	CURLINFO_HEADER_OUT => false,
        	CURLOPT_CONNECTTIMEOUT => 0, 		//indefinately
        	CURLOPT_TIMEOUT => 60, 				//in seconds
//	        CURLOPT_FOLLOWLOCATION => true, // follow redirects
//			CURLOPT_MUTE => true,
		);

		curl_setopt_array($ch, $options);
		
		$data = curl_exec($ch);
	    if ($data === false) {
	        $strError = "cURL failed. Please try to reload this page. If the problem persists - check your PHP settings.";
	        $strError .= "\n<br/>" . curl_error($ch);
	        $strError .= "\n<br/>Current Maximum Upload Size is " . ini_get('upload_max_filesize');
	        $strError .= "\n<br/>Current Maximum POST Size is " . ini_get('post_max_size');
			echo $strError;
	        return '';
	    }
		
		curl_close($ch);
		
//		return '';
		return $data;
	}

	
	
}// END class Gra4


$gra4 = new Gra4();

?>